// ============================================================================
// ==                                                                        ==
// == AMDiS - Adaptive multidimensional simulations                          ==
// ==                                                                        ==
// ============================================================================
// ==                                                                        ==
// ==  TU Dresden                                                            ==
// ==                                                                        ==
// ==  Institut fr Wissenschaftliches Rechnen                               ==
// ==  Zellescher Weg 12-14                                                  ==
// ==  01069 Dresden                                                         ==
// ==  germany                                                               ==
// ==                                                                        ==
// ============================================================================
// ==                                                                        ==
// ==  https://gforge.zih.tu-dresden.de/projects/amdis/                      ==
// ==                                                                        ==
// ============================================================================

/** \file ParallelDomainScal.h */

#ifndef AMDIS_PARALLELDOMAINSCAL_H
#define AMDIS_PARALLELDOMAINSCAL_H

#include "ParallelDomainBase.h"

namespace AMDiS {

  class ParallelDomainScal : public ParallelDomainBase
  {
  public:
    ParallelDomainScal(std::string name,
		       ProblemScal *problem,
		       ProblemInstatScal *problemInstat);

    void initParallelization(AdaptInfo *adaptInfo);

  protected:
    /// Starts the solution of the linear system using Petsc.
    void solve();

  protected:
    /// Pointer to the stationary problem.
    ProblemScal *probScal;
  };

}

#endif // AMDIS_PARALLELDOMAINSCAL_H
